<?php

/**
 * WP SMS gateway class
 *
 * @category   class
 * @package    WP_SMS
 * @version    1.0
 */
class WP_SMS_Gateway
{

	static $error_message;

	public static function gateway()
	{
		$gateways = array(
			'Bangladesh' => array(
				'muthofun' => 'Muthofun'
			)
		);

		return apply_filters('wpsms_gateway_list', $gateways);
	}

	/**
	 * Get gateway status
	 */
	public static function status()
	{
		global $sms;

		// Get credit
		$result = $sms->GetCredit();

		if (is_wp_error($result)) {
			// Set error message
			self::$error_message = $result->get_error_message();

			// Update credit
			update_option('wp_last_credit', 0);

			// Return html
			return '<div class="wpsms-no-credit"><span class="dashicons dashicons-no"></span> ' . __('Deactive!', 'wp-sms') . '</div>';
		} else {
			// Update credit
			update_option('wp_last_credit', $result);

			// Return html
			return '<div class="wpsms-has-credit"><span class="dashicons dashicons-yes"></span> ' . sprintf(__('%s', 'wp-sms'), $result) . '</div>';
		}
	}

	public static function response()
	{
		return self::$error_message;
	}

	public static function help()
	{
		global $sms;

		// Get gateway help
		return $sms->help;
	}

	public static function bulk_status()
	{
		global $sms;

		// Get bulk status
		if ($sms->bulk_send == true) {
			// Return html
			return '<div class="wpsms-has-credit"><span class="dashicons dashicons-yes"></span> ' . __('Supported', 'wp-sms') . '</div>';
		} else {
			// Return html
			return '<div class="wpsms-no-credit"><span class="dashicons dashicons-no"></span> ' . __('Does not support!', 'wp-sms') . '</div>';
		}
	}

	public static function credit()
	{
		global $sms;
		// Get credit
		$result = $sms->GetCredit();

		if (is_wp_error($result)) {
			return 0;
		} else {
			return $result;
		}
	}

}