<?php

class _500sms extends WP_SMS
{
	private $wsdl_link = "http://500sms.ir/webservice/smsService.php?wsdl";
	public $tariff = "http://500sms.ir";
	public $unitrial = true;
	public $unit;
	public $flash = "disable";
	public $isflash = false;

	public function __construct()
	{
		parent::__construct();
		$this->validateNumber = "09xxxxxxxx";

		ini_set("soap.wsdl_cache_enabled", "0");
	}

	public function SendSMS()
	{
		// Check gateway credit
		if (is_wp_error($this->GetCredit())) {
			return new WP_Error('account-credit', __('Your account does not credit for sending sms.', 'wp-sms'));
		}

		/**
		 * Modify sender number
		 *
		 * @since 3.4
		 * @param string $this ->from sender number.
		 */
		$this->from = apply_filters('wp_sms_from', $this->from);

		/**
		 * Modify Receiver number
		 *
		 * @since 3.4
		 * @param array $this ->to receiver number
		 */
		$this->to = apply_filters('wp_sms_to', $this->to);

		/**
		 * Modify text message
		 *
		 * @since 3.4
		 * @param string $this ->msg text message.
		 */
		$this->msg = apply_filters('wp_sms_msg', $this->msg);

		$receiver = array();
		foreach ($this->to as $number) {
			$receiver[] = "$number";
		}
		$client = new SoapClient($this->wsdl_link);
		$result = $client->send_sms($this->username, $this->password, $this->from, implode($receiver, ","), $this->msg);

		if ($result) {
			$this->InsertToDB($this->from, $this->msg, $this->to);

			/**
			 * Run hook after send sms.
			 *
			 * @since 2.4
			 * @param string $result result output.
			 */
			do_action('wp_sms_send', $result);

			return $result;
		}

		return new WP_Error('send-sms', $result);

	}

	public function GetCredit()
	{
		// Check username and password
		if (!$this->username && !$this->password) {
			return new WP_Error('account-credit', __('Username/Password does not set for this gateway', 'wp-sms'));
		}

		if (!class_exists('SoapClient')) {
			return new WP_Error('required-class', __('Class SoapClient not found. please enable php_soap in your php.', 'wp-sms'));
		}

		try {
			$client = new SoapClient($this->wsdl_link);
		} catch (Exception $e) {
			return new WP_Error('account-credit', $e->getMessage());
		}

		return $client->sms_credit($this->username, $this->password);
	}
}