<?php

class smsgatewayhub extends WP_SMS
{
	private $wsdl_link = "http://login.smsgatewayhub.com/api/mt/";
	public $tariff = "https://www.smsgatewayhub.com/";
	public $unitrial = true;
	public $unit;
	public $flash = "disable";
	public $isflash = false;

	public function __construct()
	{
		parent::__construct();
		$this->validateNumber = "91989xxxxxxx,91999xxxxxxx";

		// Enable api key
		$this->has_key = true;
	}

	public function SendSMS()
	{
		// Check gateway credit
		if (is_wp_error($this->GetCredit())) {
			return new WP_Error('account-credit', __('Your account does not credit for sending sms.', 'wp-sms'));
		}

		/**
		 * Modify sender number
		 *
		 * @since 3.4
		 * @param string $this ->from sender number.
		 */
		$this->from = apply_filters('wp_sms_from', $this->from);

		/**
		 * Modify Receiver number
		 *
		 * @since 3.4
		 * @param array $this ->to receiver number
		 */
		$this->to = apply_filters('wp_sms_to', $this->to);

		/**
		 * Modify text message
		 *
		 * @since 3.4
		 * @param string $this ->msg text message.
		 */
		$this->msg = apply_filters('wp_sms_msg', $this->msg);

		// Impload numbers
		$to = implode(',', $this->to);

		// Unicide message
		$msg = urlencode($this->msg);

		$response = wp_remote_get($this->wsdl_link . 'SendSMS?APIKey=' . $this->has_key . '&senderid=' . $this->from . '&channel=2&DCS=0&flashsms=0&number=' . $to . '&text=' . $msg . '&route=clickhere');

		// Check gateway credit
		if (is_wp_error($response)) {
			return new WP_Error('account-credit', $response->get_error_message());
		}

		$response_code = wp_remote_retrieve_response_code($response);

		if ($response_code == '200') {
			// Decode json
			$result = json_decode($response['body']);

			// Check response
			if ($result->ErrorMessage != 'Success')
				return new WP_Error('send-sms', $result->ErrorMessage);

			$this->InsertToDB($this->from, $this->msg, $this->to);

			/**
			 * Run hook after send sms.
			 *
			 * @since 2.4
			 * @param string $result result output.
			 */
			do_action('wp_sms_send', $result);
		} else {
			return new WP_Error('send-sms', $response['body']);
		}

		// Get data
		$result = file_get_contents($this->wsdl_link . 'SendSMS?APIKey=' . $this->has_key . '&senderid=' . $this->from . '&channel=2&DCS=0&flashsms=0&number=' . $to . '&text=' . $msg . '&route=clickhere');
	}

	public function GetCredit()
	{
		// Check username and password
		if (!$this->username && !$this->password) {
			return new WP_Error('account-credit', __('Username/Password does not set for this gateway', 'wp-sms'));
		}

		$response = wp_remote_get($this->wsdl_link . 'GetBalance?APIKey=' . $this->has_key);

		// Check gateway credit
		if (is_wp_error($response)) {
			return new WP_Error('account-credit', $response->get_error_message());
		}

		$response_code = wp_remote_retrieve_response_code($response);

		if ($response_code == '200') {
			$result = json_decode($response['body']);

			// Check response
			if ($result->ErrorMessage != 'Success')
				return new WP_Error('account-credit', $result);

			return $result->Balance;
		} else {
			return new WP_Error('account-credit', $response['body']);
		}
	}
}